Disable grub feature by default
[grml-terminalserver.git] / grml-terminalserver-config
index 39f68ab..cd50d7b 100755 (executable)
@@ -1,10 +1,9 @@
-#!/bin/sh
+#!/bin/bash
 # Filename:      terminalserver-config
-# Purpose:       Program to do something
+# Purpose:       configuration program for grml-terminalserver
 # Authors:       grml-team (grml.org), (c) Michael Gebetsroither <gebi@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Sun May 08 22:21:32 CEST 2005 [gebi]
 ################################################################################
 
 
@@ -38,7 +37,8 @@ IPRANGE_TO_=""
 NETWORK_=""
 OPTIONS_=""
 BOOT_ARGS_=""
+NAT_INTERFACE_=""
+
 
 ###
 ### __FUNCTIONS
@@ -49,23 +49,24 @@ function printUsage
   cat <<EOT
 Usage: "$PROG_NAME__" [OPTIONS] <command>
 
-$PROG_NAME__ is the config program for the terminalserver
-comming with grml.
+$PROG_NAME__ is the config program for the terminalserver coming with grml.
 
 COMMANDS:
-   help             This text
+
+   help             This help text
    interactive      Interactive Configuration of the grml-terminalserver
-   grubConf         Configure grub and make boot-image (for non-PXE NICs)
+   grubConf <file>  Configure grub and create boot-image (for non-PXE NICs)
+                      Read modules for grub from file if given.
    grubConfWrite    Configure grub and write image to floppy disk
    grubWrite        Write compiled grub-image to floppy disk
    grubMultiWrite   batchwrite grub-image to floppy disk
    initrd           Only create the initrd
    clean            Remove all configfiles created during user configuration
-   <default>        interactive
+   <default>        interactive mode
 
 OPTIONS:
-   -v             verbose (show what is going on, v++)
-   -h             this help text
+   -v               verbose (show what is going on, v++)
+   -h               this help text
 
 EOT
 }
@@ -93,6 +94,7 @@ IPRANGE_FROM_="$IPRANGE_FROM_"
 IPRANGE_TO_="$IPRANGE_TO_"
 OPTIONS_="$OPTIONS_"
 BOOT_ARGS_="$BOOT_ARGS_"
+NAT_INTERFACE_="$NAT_INTERFACE_"
 
 EOT
   notice "config successfully safed to \"$CONF_FILE_\""
@@ -119,13 +121,55 @@ function actionAutoconf
 
 
 # INITRD {{{
-
 function actionMkInitrd
 {
-  echo "Creating initrd: $PATH_/minirt26.gz"
-  isExistent "$PATH_/minirt26.gz" && echo "$PATH_/minirt26.gz does already exist, skipping initrd creation" && return 0
-  mkInitrd
-  echo 'done'
+  echo
+  echo "Creating initrd $PATH_/minirt26.gz:"
+  if isExistent "$PATH_/minirt26.gz" ; then
+     echo
+     echo "$PATH_/minirt26.gz exists already, skipping initrd creation"
+     return 0
+  fi
+
+  if [ -e '/live/cow' ]; then
+    mkInitrdNew
+  else
+    mkInitrd
+  fi
+  echo '... done'
+}
+
+function mkInitrdNew
+{
+  # we do not want to include persistent configuration files
+  # from udev in the initrd
+  udev_tmp_=$(mktemp -d terminalserver__udev.XXXXXX)
+  persistent=false
+  if ls /etc/udev/rules.d/*persistent* >/dev/null 2>&1 ; then
+    persistent_files=true
+    for f in /etc/udev/rules.d/*persistent* ; do
+      mv "$f" "${udev_tmp_}/"
+    done
+  fi
+
+  set -e
+  local cfg_="/etc/initramfs-tools/initramfs.conf"
+  local tmp_="`mktemp -t terminalserver__initramfsbk.XXXXXX`"
+  cp $cfg_ $tmp_
+  sed -i 's/^MODULES=.*/MODULES=netboot/' $cfg_
+  update-initramfs -u -t 1>/dev/null
+  mv $tmp_ $cfg_
+
+  local initrd_="/boot/initrd.img-$KERNEL_VERSION_"
+  mv $initrd_ $PATH_/minirt26.gz
+  mv ${initrd_}.bak $initrd_
+  set +e
+
+  # restore udev configuration files
+  if $persistent_files ; then
+    mv ${udev_tmp_}/* /etc/udev/rules.d/
+    rmdir "${udev_tmp_}"
+  fi
 }
 
 function mkInitrd
@@ -150,42 +194,37 @@ function mkInitrd
   execute "rm $TMP_DIR_/minirt26" warn || return 1
 
   # implanting my initrd changes into the original initrd
-  
+
   # copy programs, check if there are already links with this name to busybox
-  for i in $USR_SHARE_/discover* $USR_SHARE_/udhcpc $USR_SHARE_/udhcp-config.sh $USR_SHARE_/cdir $USR_SHARE_/rdir /usr/bin/ldd ;do
+  for i in $USR_SHARE_/timeout $USR_SHARE_/udhcp-config.sh $USR_SHARE_/cdir $USR_SHARE_/rdir; do
     tmp_name_="${i##*/}"
     isNotExistent "$INITRD_/static/$tmp_name_" eprint || execute "rm $INITRD_/static/$tmp_name_"
     cp $i "$INITRD_/static/$tmp_name_"
   done
   cp $USR_SHARE_/linuxrc $INITRD_/
   mkdir -p $INITRD_/mylib
-  mkdir -p $INITRD_/myusr/i386-uclibc-linux/lib
-  for i in libdl libc libuClibc ld-uClibc; do
-    cp -a $UCLIBC_PATH_/$i*.so* $INITRD_/myusr/i386-uclibc-linux/lib
-  done
-
-  # copy data files for discover (discover-data)
-  mkdir -p $INITRD_/mylib/discover
-  cp /lib/discover/list.xml /lib/discover/pci-*.xml $INITRD_/mylib/discover/
-
+  mkdir -p $INITRD_/myusr
 
   #
   # which modules should i put into the ramdisk
   #
 
-  # get cards detected by discover
-  isNotExistent $CARDS_DETECTED_BY_DISCOVER && awk '/ethernet/{print $3}' /lib/discover/pci.lst |sort |uniq > $CARDS_DETECTED_BY_DISCOVER
+  # find *all* network drivers, but do not include wlan/pcmcia/... related ones
+  # blacklist: proteon and depca as they seem to cause problems with udevsettle
+  find ${MODULES_PATH_}/${KERNEL_VERSION_}/kernel/drivers/net/ -name \*.ko | \
+    grep -v 'wireless\|wan\|hamradio\|wlan\|ppp\|irda\|pcmcia\|depca\|proteon' | \
+      sed 's#.*./## ; s#\.ko##' | sort | uniq > $CARDS_DETECTED_BY_DISCOVER
 
   local modules="`cat $CARDS_DETECTED_BY_DISCOVER |xargs` af_packet"
   local modules_dep=""
 
-  # get paths of modules + paths of all dependet modules
+  # get paths of modules + paths of all dependent modules
   echo -n "" >"$TMP_"
   for i in $modules; do
     tmp_=`awk -F: '{if($1~/'"$i".ko'/) {print $0}}' $MODULES_PATH_/$KERNEL_VERSION_/modules.dep`
     echo "${tmp_%%:*}"
     # FIXME ugly sed hack :(
-    echo "${tmp_#*:}" |xargs -n1 echo |sed 's/://'
+    echo "${tmp_#*:}" | xargs -n1 echo | sed 's/://'
   done \
   | sort | uniq | while read module relax; do
     if [ -n "$module" ]; then
@@ -213,16 +252,18 @@ function mkInitrd
     cp $MODULES_PATH_/$KERNEL_VERSION_/kernel/$i "$tmp_path"
   done
 
-  # generate modules.dep
+  # copying modules.*
   cp $MODULES_PATH_/$KERNEL_VERSION_/modules.dep $mod_path_
+  cp $MODULES_PATH_/$KERNEL_VERSION_/modules.alias $mod_path_
   #grep "^\/lib\/modules\/$KERNEL_VERSION_\/kernel\/" $MODULES_PATH_/$KERNEL_VERSION_/modules.dep |\
   #  sed "s/\/lib\/modules\/$KERNEL_VERSION_\/kernel\//\/modules\//g" > $mod_path_/modules.dep
 
   # put everything into the new initrd
   local tmp_size=`du -s $INITRD_ |awk '{print $1}'`   # in kB
   let tmp_size=$tmp_size+1000
-  if (( $tmp_size >= 16000 )); then
-    warn "Your initrd is $tmp_size kByte large => TOO BIG (should be 16000kByte)"
+  local max_size=24000
+  if (( $tmp_size >= $max_size )); then
+    warn "Your initrd is $tmp_size kByte large => TOO BIG (should be <= ${max_size}kB)"
     warn "Please remove a few modules from $CARDS_DETECTED_BY_DISCOVER or edit $INITRD_ manually"
     return 1
   fi
@@ -255,7 +296,7 @@ function actionInteractive
   local i=""
 
   dprint "running in interactive mode"
-  
+
   local card_title_="Choose network device connected to client network"
   local card_message_="Available network devices:"
   local iprange_title_="IP Address range for clients"
@@ -272,9 +313,9 @@ for addresses from 192.168.0.101 to (and including) 192.168.0.200.
   local runconfig_message_="Would you like to configure your interfaces now?"
   local grub_title_="Grub configuration"
   local grub_message_="Do you have any NON-PXE network cards you would like to boot from?"
-  
+
   # on witch interfaces should we listen
-  local netdevices_="$(cat /proc/net/dev | awk -F: '/eth.:|tr.:/{print $1}')"
+  local netdevices_="$(grep -ve 'lo:' -ve 'Inter-|' -ve 'face |bytes' /proc/net/dev | awk -F: '{print $1}')"
   local device_list_=""
   for INTERFACE_ in $netdevices_; do device_list_="$device_list_ ${INTERFACE_} Networkcard_${INTERFACE_##eth}"; done
     echo -n "" >"$TMP_"
@@ -312,28 +353,53 @@ for addresses from 192.168.0.101 to (and including) 192.168.0.200.
 
   NAMESERVERS_=`netGetNameservers warn`
   GW_=`netGetDefaultGateway warn`
+  GW_DEV_=`/sbin/ip route get "$GW_" | awk '{ print $3; exit; }'`
+  if [ "$GW_DEV_" != "$INTERFACE_" ] && [ "$GW_DEV_" != "" ]; then
+    # GW_DEV_ of server is not the same device as the one serviced by dhcpd
+    # so it doesn't make sense to provide the GW_ address to the clients
+    local do_nat_="YES"
+    local do_nat_title_="Network Address Translation"
+    local do_nat_message_="
+Do you want to set up NAT so that clients booting from this
+grml-terminalserver can use this machine also as gateway to
+the internet?"
+
+    $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$do_nat_title_" --yesno "$do_nat_message_" 15 75 || \
+      do_nat_="NO"
+    if [ "$do_nat_" = "YES" ]; then
+      # user wants NAT, we give the clients the server address as
+      # gateway as well
+      GW_="$IP_"
+      NAT_INTERFACE_="$GW_DEV_"
+    else
+      # no NAT, no sensible gateway
+      GW_=""
+      NAT_INTERFACE_=""
+    fi
+  fi
 
 
-  # grub
-  echo -n "" >"$TMP_"
-  local grub_write_="YES"
-  $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$grub_title_" --yesno "$grub_message_" 5 75 && \
-    grubConfig || grub_write_="NO"
+  # grub -> do not use it anymore
+  # echo -n "" >"$TMP_"
+  # local grub_write_="YES"
+  # $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$grub_title_" --yesno "$grub_message_" 5 75 && \
+  #  grubConfig || grub_write_="NO"
+  grub_write_="NO"
+
 
   # get options
   #local OPT_IPTABLES_="yes"
   #local OPT_SSH_="yes"
   #local OPT_DISTCC_="yes"
   #local OPT_SQUID_=""
-  
+
   local OPTIONS_TITLE_="Options"
   local OPTIONS_MESSAGE_="Please give the appropriate options you want the clients to use:
 
 grml2hd   - Make a non-interactive remote installation
 
 
+
 "
 #  local OPTIONS_MESSAGE_="Please give the appropriate options you want the clients to use:
 #
@@ -373,10 +439,9 @@ Quite usefull examples:
 
 ssh=<pw>              - Start ssh server and set password of user grml to pw
 services=<1,2,3>      - Execute /etc/init.d/{1,2,3} start
-console=ttyS0,9600n8  - Initialise seriell console
-secure                - Boot only restricted clients (without root permissions)
-startx                - Boot into X (should be used with secure)
+console=ttyS0,9600n8  - Initialise serial console
+startx                - Boot into X
+
 
 "
   $DIALOG_ --clear --no-collapse --backtitle "$BACK_TITLE_" --title "$OPTIONS_TITLE_" --inputbox "$OPTIONS_BOOTARG_MESSAGE_" 0 0\
@@ -398,27 +463,27 @@ function optGrml2Hd
   local GRML2HD_TITLE_='Grml2hd options dialog'
   local tmp_=''
   local options_='BOOT_IMAGE=grml2hd'
-  
+
   # get partition to install grml2hd on
-  OPTIONS_PARTITION_MSG_='Please give me the target partition where to install grml'
+  OPTIONS_PARTITION_MSG_='Please specify the target partition where to install grml'
   PARTITION_TITLE_='Partition selection'
   echo -n "" >"$TMP_"
   $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$PARTITION_TITLE_" --inputbox \
     "$OPTIONS_PARTITION_MSG_" 0 75 '/dev/hda1' 2>$TMP_ || die "problems getting partition"
   tmp_="partition=$(<$TMP_)"
   options_="$options_ $tmp_"
-  
+
   # get filesystem type
-  OPTION_FS_TYPE_='Please give me the filesystem type'
+  OPTION_FS_TYPE_='Please specify the filesystem type'
   FS_TITLE_='Filesystem selection'
   echo -n "" >"$TMP_"
   $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$FS_TITLE_" --inputbox \
   "$OPTION_FS_TYPE_" 0 75 'ext3' 2>$TMP_ || die "problems getting filesystem type"
   tmp_="filesystem=$(<$TMP_)"
   options_="$options_ $tmp_"
-    
+
   # get where to save mbr
-  OPTION_MBR_='Please give me the location where to save the mbr'
+  OPTION_MBR_='Please specify the location where to save the mbr'
   MBR_TITLE_='Select location of mbr'
   echo -n "" >"$TMP_"
   $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$MBR_TITLE_" --inputbox \
@@ -445,7 +510,7 @@ function grubConfig
   local tmp_=`mktemp -td terminalserver_grub.XXXXXX` || warn "could not create tmp file for grubConfig"
   if [ -z "$tmp_" ]; then return 1; fi
 
-  grubConfigWork $tmp_
+  grubConfigWork "$tmp_" "$1"
   local ret_=$?
   execute "rm -rf $tmp_" warn
 
@@ -458,25 +523,32 @@ function grubConfigWork
 
   local grub_title_="Grub configuration"
   local grub_nic_message_="
-Give me the types of network cards you would want to boot from.
-If you networkcard is already listed press <OK>!
+Please select the types of network cards you want to boot from.
+If your networkcard is already listed just press <OK>!
 
-WARNING: DON't add all NIC's, grub could possibly stop working!!"
+WARNING: Do NOT add all NICs, grub could possibly stop working!"
   local nics_=""
 
-  while read module_ desc_ mode_; do
-    nics_="$nics_ $module_ $desc_ $mode_"
-  done < $GRUB_NIC_CONF_
-
-  echo -n "" >$TMP_
-  local cmd_line_=""
-  $DIALOG_ --clear --separate-output --backtitle "$BACK_TITLE_" --title "$grub_title_" --checklist \
-    "$grub_nic_message_" 10 70 0 $nics_ 2>$TMP_
-  local ret_=$?
-  if [[ $ret_ -ne 0 || `wc -l <$TMP_` -eq 0 ]]; then
-    echo $ret_
-    warn "you should give me your specified NICs but didn't => DEFAULT will be used"
-    awk '/ on$/{print $1}' $GRUB_NIC_CONF_ >$TMP_
+  if [[ $2 == "" ]]; then
+    while read module_ desc_ mode_; do
+      nics_="$nics_ $module_ $desc_ $mode_"
+    done < $GRUB_NIC_CONF_
+
+    echo -n "" >$TMP_
+    local cmd_line_=""
+    $DIALOG_ --clear --separate-output --backtitle "$BACK_TITLE_" --title "$grub_title_" --checklist \
+      "$grub_nic_message_" 10 70 0 $nics_ 2>$TMP_
+    local ret_=$?
+    if [[ $ret_ -ne 0 ]]; then
+       die "exiting as requested"
+    fi
+    if [[ `wc -l <$TMP_` -eq 0 ]]; then
+      echo $ret_
+      warn "you should specify the NICs but didn't => DEFAULT will be used"
+      awk '/ on$/{print $1}' $GRUB_NIC_CONF_ >$TMP_
+    fi
+  else
+    cat $2 >$TMP_
   fi
   while read module_; do
     cmd_line_="$cmd_line_ --enable-$module_"
@@ -485,12 +557,13 @@ WARNING: DON't add all NIC's, grub could possibly stop working!!"
   echo "\"$cmd_line_\""
 
   execute "tar xzf $GRUB_SOURCE_ -C $tmp_" warn || return 1
+  local_dir="$(pwd)"
   execute "cd $tmp_/grub*" warn || return 1
 cat >preset-menu <<EOT
 # Set up the serial terminal, first of all.
 #serial --unit=0 --speed=19200
 #terminal --timeout=0 serial
-    
+
 # Initialize the network.
 #dhcp --with-configfile
 #bootp --with-configfile
@@ -500,17 +573,26 @@ timeout 0
 title Load config from Tftp server
   configfile (nd)/menu.lst
 EOT
-  #execute "./configure --enable-diskless --enable-preset-menu=./preset-menu $cmd_line_" warn || read
-  execute "./configure --enable-preset-menu=./preset-menu $cmd_line_" warn || read
-  execute "make -j2 CC=gcc-3.3" warn || read #return 1
+
+  CC='gcc'
+  test -r /lib64 && export CC="$CC -m32"
+
+  CC="$CC" execute "./configure --enable-preset-menu=./preset-menu $cmd_line_" warn || read
+  CC="$CC" execute "make -j2" warn || read #return 1
 
   local st1_="stage1/stage1"
   local st2_="stage2/stage2"
   isExistent $st1_ warn || return 1
   isExistent $st2_ warn || return 1
 
-  execute "mv -fb $PATH_/grub.img $PATH_/grub.img.old"
+  if [ -r "$PATH_/grub.img" ] ; then
+     execute "mv -fb $PATH_/grub.img $PATH_/grub.img.old"
+  fi
+
   execute "cat $st1_ $st2_ > $PATH_/grub.img" warn || return 1
+
+  cd "$local_dir"
+
   return 0
 }
 
@@ -518,7 +600,7 @@ function grubWrite
 {
   local grub_title_="Grub configuration"
   $DIALOG_ --clear --backtitle "$BACK_TITLE_" --title "$grub_title_" --yesno \
-    "Do you want to write your grub image to /dev/fd0" 5 75 || return 1
+    "Do you want to write the grub image to /dev/fd0" 5 75 || return 1
 
   execute "dd if=$PATH_/grub.img of=/dev/fd0" warn || return 0
   return 1
@@ -527,8 +609,8 @@ function grubWrite
 function grubMultiWrite
 {
   local target_=${1:-'/dev/fd0'}
-  
-  isExistent "$PATH_/grub.img" die "you must give me an image or run \"$PROG_NAME__ grubconf\""
+
+  isExistent "$PATH_/grub.img" die "you have to specify an image or run \"$PROG_NAME__ grubconf\""
   isExistent "$target_" die "$target_ is not a valied"
   while true; do
     echo -n "Please insert disk into $target_ and press <ENTER> (STRG-C for end)"
@@ -575,7 +657,7 @@ setVerbose $verbose_
 case "$1" in
   help)   printUsage; exit 0 ;;
 esac
-  
+
 checkRoot die 'You have to be root to use this program'
 disableSyslog
 
@@ -598,11 +680,11 @@ KERNEL_VERSION_=\"$KERNEL_VERSION_\" \
 ORIGINAL_INITRD_=\"$ORIGINAL_INITRD_\""
   die "False configuration, please update $CONFIG_"
 fi
-    
+
 
 case "$1" in
   interactive)  actionInteractive ;;
-  grubConf)   grubConfig ;;
+  grubConf)   grubConfig "$2" ;;
   grubConfWrite)  grubConfig && grubWrite ;;
   grubWrite)    grubWrite ;;
   grubMultiWrite)   grubMultiWrite "$2" ;;